module.exports = (grunt) => {
  grunt.initConfig({
    babel: {
      options: {
        plugins: [
          'transform-object-rest-spread',
          'transform-es2015-shorthand-properties',
        ],
      },
      dist: {
        files: [{
          expand: true,
          cwd: './src/',
          src: ['**/*.js'],
          dest: './dist/',
        }],
      },
    },
    clean: {
      dist: {
        src: ['./dist/**/*.*']
      },
    },
    watch: {
      src: {
        files: ['src/**/*.*'],
        tasks: ['default'],
        options: {
          interrupt: true,
        },
      },
    },
  });

  grunt.loadNpmTasks('grunt-babel');
  grunt.loadNpmTasks('grunt-contrib-clean');
  grunt.loadNpmTasks('grunt-contrib-watch');

  grunt.registerTask(
    'default',
    [
      'clean',
      'babel',
    ]
  );
};
